#!/usr/bin/perl

use strict;
use warnings;


`mkdir -p tempdir`;

my $i = 0;

#maximale anzahl an durchlufen, d.h. ein archiv darf ca bis zu $max_durchlaeufe unterarchive enthalten
my $max_durchlaeufe = 25;

for ($i=0; $i < $max_durchlaeufe; $i++){
	my @array = `file *`;

	foreach my $line (@array){
		#$args[0] = filename ; $args[1] = fileinfo
		my @args = split /:\s*/, $line;

		if ($args[1] =~ m#RAR archive data#){
			#print $args[0] . "\n";
			`unrar e "$args[0]" tempdir/`;
			`find tempdir/ -type f | while read zeile; do mv "\$zeile" ./\`sha1sum "\$zeile" | awk '{print \$1}'\`; done`;
			unlink $args[0];
			`rm -rf tempdir/*`;
		}
		if ($args[1] =~ m#Zip archive data#){
			#print $args[0] . "\n";
			`unzip -d tempdir -P infected "$args[0]"`;
			`find tempdir/ -type f | while read zeile; do mv "\$zeile" ./\`sha1sum "\$zeile" | awk '{print \$1}'\`; done`;
			unlink $args[0];
			`rm -rf tempdir/*`;
		}
	}
}


`rm -rf tempdir/`;
